SystemOrganization addCategory: #Traceling!

Exception subclass: #TrcTracingImbalance
	instanceVariableNames: 'expectedClass expectedSelector returnedClass returnedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
expectedClass

	^ expectedClass! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
expectedClass: anObject

	expectedClass := anObject! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
expectedSelector

	^ expectedSelector! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
expectedSelector: anObject

	expectedSelector := anObject! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
returnedClass

	^ returnedClass! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
returnedClass: anObject

	returnedClass := anObject! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
returnedSelector

	^ returnedSelector! !

!TrcTracingImbalance methodsFor: 'accessing' stamp: 'toma 1/23/2017 18:45'!
returnedSelector: anObject

	returnedSelector := anObject! !

Object subclass: #TrcClass
	instanceVariableNames: 'methods baseClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

!TrcClass class methodsFor: 'as yet unclassified' stamp: 'toma 1/18/2017 15:41'!
on: aClass tracer: tracer
	| methods |
	methods :=  aClass methodDictionary keys collect: [ :selector |
		TrcMethod onClass: aClass selector: selector tracer: tracer].
	^(TrcClass new)
			methods: methods;
			baseClass: aClass;
			yourself! !

!TrcClass methodsFor: 'accessing' stamp: 'toma 1/18/2017 15:41'!
baseClass

	^ baseClass! !

!TrcClass methodsFor: 'accessing' stamp: 'toma 1/18/2017 15:41'!
baseClass: anObject

	baseClass := anObject! !

!TrcClass methodsFor: 'as yet unclassified' stamp: 'toma 1/17/2017 18:04'!
install
	self methods do: [ :each | each install ]! !

!TrcClass methodsFor: 'accessing' stamp: 'toma 1/17/2017 18:01'!
methods

	^ methods! !

!TrcClass methodsFor: 'accessing' stamp: 'toma 1/17/2017 18:01'!
methods: anObject

	methods := anObject! !

!TrcClass methodsFor: 'as yet unclassified' stamp: 'toma 1/17/2017 18:04'!
uninstall
	self methods do: [ :each | each uninstall ]! !

Object subclass: #TrcExample
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

!TrcExample methodsFor: 'as yet unclassified' stamp: 'toma 1/18/2017 11:20'!
bar
	^self foo: 1! !

!TrcExample methodsFor: 'as yet unclassified' stamp: 'toma 1/24/2017 16:07'!
ensureCont: anInteger
	(anInteger == 0)
		ifTrue: [Transcript showln: 'bottom out'. 
			^0]
		ifFalse: [
			[anInteger]
				ensure: [[^WAContinuation currentDo: [ :cc | 
							'cc enter ', anInteger. 
							[cc value: (1 + (self ensureCont: (anInteger - 1)))]
								ensure: ['cc leave ', anInteger]]]
					ensure: ['leave ', anInteger]]]
	! !

!TrcExample methodsFor: 'as yet unclassified' stamp: 'toma 1/24/2017 14:28'!
ensureStuff: anObject
	[Transcript showln: 'enter'] ensure: [
		[self error: anObject. ^anObject] ensure: [
			Transcript showln: 'exit']]! !

!TrcExample methodsFor: 'as yet unclassified' stamp: 'toma 1/17/2017 17:01'!
foo: aNumber
	counter := counter + aNumber.
	^counter! !

!TrcExample methodsFor: 'as yet unclassified' stamp: 'toma 1/17/2017 17:01'!
initialize
	counter := 0! !

Object subclass: #TrcMethod
	instanceVariableNames: 'selector baseMethod baseClass tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

!TrcMethod class methodsFor: 'as yet unclassified' stamp: 'toma 1/17/2017 17:00'!
onClass: class selector: selector tracer: tracer
	^(TrcMethod new)
			baseClass: class;
			selector: selector;
			tracer: tracer;
			baseMethod: (class methodDictionary at: selector);
			yourself! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:25'!
baseClass

	^ baseClass! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:25'!
baseClass: anObject

	baseClass := anObject! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:25'!
baseMethod

	^ baseMethod! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:25'!
baseMethod: anObject

	baseMethod := anObject! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/17/2017 17:05'!
flushCache
	"Don't mind me"! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 14:00'!
getSourceFor: selector in: class
	^self baseMethod getSourceFor: selector in: class! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 11:22'!
hasBreakpoint
	^false! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 11:30'!
hasReportableSlip
	^false! !

!TrcMethod methodsFor: 'tracing' stamp: 'toma 1/17/2017 16:26'!
install
	self baseClass methodDictionary at: self selector put: self! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/24/2017 15:34'!
last
	^self baseMethod last! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 11:26'!
literalsDo: aBlock
	^self baseMethod literalsDo: aBlock! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 14:38'!
methodReference
	^self baseMethod methodReference! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/20/2017 13:24'!
pragmaAt: aKey
	^self baseMethod pragmaAt: aKey! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 11:30'!
primitive
	^self baseMethod primitive! !

!TrcMethod methodsFor: 'tracing' stamp: 'toma 1/24/2017 14:33'!
run: selector with: arguments in: receiver 
	| result |
	[self tracer enter: selector with: arguments in: receiver]
		ensure: [[result := self baseMethod
				valueWithReceiver: receiver
				arguments: arguments.
			^ result]
				ensure: [self tracer	return: result from: selector in: receiver]]! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:25'!
selector

	^ selector! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:25'!
selector: anObject

	selector := anObject! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 14:39'!
sourcePointer
	^self baseMethod sourcePointer! !

!TrcMethod methodsFor: 'method-decorator' stamp: 'toma 1/18/2017 13:59'!
timeStamp
	^self baseMethod timeStamp! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:34'!
tracer

	^ tracer! !

!TrcMethod methodsFor: 'accessing' stamp: 'toma 1/17/2017 16:34'!
tracer: anObject

	tracer := anObject! !

!TrcMethod methodsFor: 'tracing' stamp: 'toma 1/17/2017 17:04'!
uninstall
	self baseClass methodDictionary at: self selector put: (self baseMethod)! !

Object subclass: #TrcTracelet
	instanceVariableNames: 'tracedClass selector children parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 3/17/2017 14:58'!
callRelationsCollect: aBlock
	| collection |
	collection := OrderedCollection new.
	self callRelationsDo: [ :caller :callee |
		collection add: (aBlock value: caller value: callee).
		true].
	^ collection
	! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 3/17/2017 14:40'!
callRelationsDo: aBlock
	self children do: [:each | 
		(aBlock value: self value: each)
		ifTrue: [each callRelationsDo: aBlock]]! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/19/2017 20:40'!
children

	^ children ifNil: [children := OrderedCollection new]! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/19/2017 18:33'!
children: anObject

	children := anObject! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 1/20/2017 14:07'!
count
	^self children inject: 1 into: [ :count :next | count + next count]! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 5/12/2017 14:29'!
fileOut: fileName
	| fileStream |
	fileStream := FileStream fileNamed: fileName.
	self serializeOn: fileStream.
	fileStream flush; close.! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2017 16:36'!
identifer
	^{self tracedClass name asSymbol. self selector asSymbol}! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/20/2017 11:19'!
parent

	^ parent! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/20/2017 11:19'!
parent: anObject

	parent := anObject! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 1/20/2017 13:38'!
printOn: aStream
	aStream
		nextPutAll: self tracedClass printString;
		nextPutAll: ' » ';
		nextPutAll: self selector printString! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/19/2017 18:33'!
selector

	^ selector! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/19/2017 18:33'!
selector: anObject

	selector := anObject! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 1/23/2017 16:48'!
serializeChildrenOn: aStream
	self children do: [:each | 
		each serializeOn: aStream].
		! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 1/23/2017 16:48'!
serializeOn: aStream
	aStream
		nextPutAll: '(';
		nextPutAll: self tracedClass name;
		nextPutAll: ' ';
		nextPutAll: self selector;
		nextPutAll: ' '.
	self serializeChildrenOn: aStream.
	aStream nextPutAll: ')'.
		! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/19/2017 18:39'!
tracedClass

	^ tracedClass! !

!TrcTracelet methodsFor: 'accessing' stamp: 'toma 1/19/2017 18:39'!
tracedClass: anObject

	tracedClass := anObject! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 3/17/2017 14:37'!
within: aClass pop: aSelector
	((self tracedClass == aClass) and: [self selector = aSelector] and: [self parent notNil])
		ifTrue: [^ self parent]
		ifFalse: [self halt "Irrecoverable tracing imbalance, e.g. untraced call/cc"]! !

!TrcTracelet methodsFor: 'as yet unclassified' stamp: 'toma 1/19/2017 20:34'!
within: aClass push: aSelector
	| tracelet |
	tracelet := (TrcTracelet new)
			selector: aSelector;
			tracedClass: aClass;
			parent: self;
			yourself.
	self children add: tracelet.
	^tracelet! !

Object subclass: #TrcTracer
	instanceVariableNames: 'classes tracelet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

TrcTracer subclass: #TrcTestTracer
	instanceVariableNames: 'testCases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traceling'!

!TrcTestTracer commentStamp: 'toma 2/13/2017 16:05' prior: 0!
Example: 

trc := TrcTestTracer new.
trc registerCategoryPrefix: 'JSON'.
trc registerTestsPrefix: 'JSON'.
trc testInstancesDo: [:inst | Transcript showln: inst ].
trc runTests.
trc trace: [trc runTests].
trc tracelet. "inspect"
trc tracelet count. "print"

fs := FileStream fileNamed: 'test.trace'.
trc tracelet serializeChildrenOn: fs.
fs flush; close.
!

!TrcTestTracer methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2017 16:18'!
debugTests
	self testInstancesDo: [ :case | case debug]! !

!TrcTestTracer methodsFor: 'accessing' stamp: 'toma 1/25/2017 15:42'!
initialize 
	super initialize.
	self testCases: Set new.! !

!TrcTestTracer methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2017 16:12'!
registerTestsPrefix: categoryPrefix
	(TestCase subclasses
		select: [:cls | cls category beginsWith: categoryPrefix])
		do: [:cls |	self testCases add: cls]! !

!TrcTestTracer methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2017 16:19'!
runTests
	^self runTests: TestResult new.! !

!TrcTestTracer methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2017 16:19'!
runTests: aResult
	self testInstancesDo: [ :case | case run: aResult].
	^aResult! !

!TrcTestTracer methodsFor: 'accessing' stamp: 'toma 1/25/2017 15:42'!
testCases

	^ testCases! !

!TrcTestTracer methodsFor: 'accessing' stamp: 'toma 1/25/2017 15:42'!
testCases: anObject

	testCases := anObject! !

!TrcTestTracer methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2017 16:27'!
testInstancesDo: aBlock
	self testCases do: [ :test |
		test allTestSelectors do: [:sel |
			aBlock value: (test selector: sel)]]
	! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/17/2017 18:08'!
attachTo: aClass
  (self tracingClassFor: aClass) install! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:09'!
classTracersDo: aBlock
	self classes valuesDo: [ :each | aBlock value: each ]! !

!TrcTracer methodsFor: 'accessing' stamp: 'toma 1/17/2017 18:05'!
classes

	^ classes! !

!TrcTracer methodsFor: 'accessing' stamp: 'toma 1/17/2017 18:05'!
classes: anObject

	classes := anObject! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/17/2017 18:09'!
detachFrom: aClass
  (self tracingClassFor: aClass) uninstall! !

!TrcTracer methodsFor: 'trace-callbacks' stamp: 'toma 1/20/2017 13:21'!
enter: selector with: arguments in: receiver.
	"Transcript showln: (receiver class name), ' >> ', selector, ' { '."
	self tracelet: (self tracelet within: receiver class push: selector)! !

!TrcTracer methodsFor: 'trace-callbacks' stamp: 'toma 1/23/2017 18:50'!
failFrom: selector in: receiver
	self tracelet: (self tracelet within: (receiver class) pop: selector)! !

!TrcTracer methodsFor: 'as yet unclassified' stamp: 'toma 5/12/2017 14:31'!
fileOut: fileName
	self tracelet fileOut: fileName! !

!TrcTracer methodsFor: 'initialize-release' stamp: 'toma 1/19/2017 20:37'!
initialize 
	self
		classes: Dictionary new;
		tracelet: TrcTracelet new! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:54'!
install
	self classes valuesDo: [:classTracer | classTracer install]! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:41'!
registerCategory: aSymbol
	
	(Smalltalk organization classesInCategory: aSymbol) do: [:each |
		self registerClass: each]! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 2/2/2017 16:12'!
registerCategoryPrefix: aSymbol

	| cats |
	cats :=  Smalltalk organization categories select: [ :cat | 
		(cat beginsWith: aSymbol)].
	
	cats do: [ :cat | self registerCategory: cat].! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:06'!
registerClass: aClass
	self tracingClassFor: aClass! !

!TrcTracer methodsFor: 'as yet unclassified' stamp: 'toma 1/20/2017 14:04'!
reset
	self tracelet: TrcTracelet new.! !

!TrcTracer methodsFor: 'trace-callbacks' stamp: 'toma 1/23/2017 18:50'!
return: result from: selector in: receiver
	"Transcript showln: '}'."
	self tracelet: (self tracelet within: (receiver class) pop: selector)! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/20/2017 11:18'!
trace: aBlock
	| result |
	
	self install.
	[result := aBlock value] ensure: [self uninstall].
	^result! !

!TrcTracer methodsFor: 'accessing' stamp: 'toma 1/19/2017 20:36'!
tracelet

	^ tracelet! !

!TrcTracer methodsFor: 'accessing' stamp: 'toma 1/19/2017 20:36'!
tracelet: anObject

	tracelet := anObject! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 11:17'!
tracingClassFor: aClass
	| result |
	self classes at: aClass 
		ifPresent: [:value | result := value]
		ifAbsentPut: [result := TrcClass on: aClass tracer: self].
	^result! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:54'!
uninstall
	self classes valuesDo: [:classTracer | classTracer uninstall]! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:43'!
unregisterCategory: aSymbol
	self classes
		select: [:each | each baseClass category = aSymbol]
		thenCollect: [:each | self unregisterClass: each baseClass ] ! !

!TrcTracer methodsFor: 'tracing' stamp: 'toma 1/18/2017 15:07'!
unregisterClass: aClass
	self classes removeKey: aClass! !
